searchNodes=[{"doc":"A function decorator for OpenTelemetry traces. Installation Add open_telemetry_decorator to your list of dependencies in mix.exs . We include the opentelemetry_api package, but you'll need to add opentelemetry yourself in order to report spans and traces. def deps do [ { :open_telemetry_decorator , &quot;~&gt; 1.0.0-rc.3&quot; } , { :opentelemetry , &quot;~&gt; 1.0.0-rc.3&quot; } ] end Then follow the directions for the exporter of your choice to send traces to to zipkin, honeycomb, etc. https://github.com/garthk/opentelemetry_honeycomb https://github.com/opentelemetry-beam/opentelemetry_zipkin Usage Add use OpenTelemetryDecorator to the module, and decorate any methods you want to trace with @decorate trace(&quot;span name&quot;) . The trace decorator will automatically wrap the decorated function in an opentelemetry span with the provided name. defmodule MyApp.Worker do use OpenTelemetryDecorator @decorate trace ( &quot;worker.do_work&quot; ) def do_work ( arg1 , arg2 ) do ... doing work end end Span Attributes The trace decorator allows you to specify an includes option which gives you more flexibility with what you can include in the span attributes. Omitting the includes option with trace means no attributes will be added to the span. defmodule MyApp.Worker do use OpenTelemetryDecorator @decorate trace ( &quot;worker.do_work&quot; , include : [ :arg1 , :arg2 ] ) def do_work ( arg1 , arg2 ) do ... doing work end end The decorator uses a macro to insert code into your function at compile time to wrap the body in a new span and link it to the currently active span. In the example above, the do_work method would become something like this: def do_work ( arg1 , arg2 ) do require OpenTelemetry.Span require OpenTelemetry.Tracer parent_ctx = OpenTelemetry.Tracer . current_span_ctx ( ) OpenTelemetry.Tracer . with_span &quot;my_app.worker.do_work&quot; , %{ parent : parent_ctx } do ... doing work OpenTelemetry.Span . set_attributes ( arg1 : arg1 , arg2 : arg2 ) end end You can provide span attributes by specifying a list of variable names as atoms. This list can include... Any variables (in the top level closure) available when the function exits: defmodule MyApp.Math do use OpenTelemetryDecorator @decorate trace ( &quot;my_app.math.add&quot; , include : [ :a , :b , :sum ] ) def add ( a , b ) do sum = a + b { :ok , thing1 } end end The result of the function by including the atom :result : defmodule MyApp.Math do use OpenTelemetryDecorator @decorate trace ( &quot;my_app.math.add&quot; , include : [ :result ] ) def add ( a , b ) do sum = a + b { :ok , thing1 } end end Map/struct properties using nested lists of atoms: defmodule MyApp.Worker do use OpenTelemetryDecorator @decorate trace ( &quot;my_app.worker.do_work&quot; , include : [ [ :arg1 , :count ] , [ :arg2 , :count ] , :total ] ) def do_work ( arg1 , arg2 ) do total = arg1 . count + arg2 . count { :ok , total } end end","ref":"OpenTelemetryDecorator.html","title":"OpenTelemetryDecorator","type":"module"},{"doc":"","ref":"OpenTelemetryDecorator.html#trace/1","title":"OpenTelemetryDecorator.trace/1","type":"macro"},{"doc":"","ref":"OpenTelemetryDecorator.html#trace/2","title":"OpenTelemetryDecorator.trace/2","type":"macro"},{"doc":"Decorate a function to add an OpenTelemetry trace with a named span. You can provide span attributes by specifying a list of variable names as atoms. This list can include: any variables (in the top level closure) available when the function exits, the result of the function by including the atom :result , map/struct properties using nested lists of atoms. defmodule MyApp.Worker do use OpenTelemetryDecorator @decorate trace ( &quot;my_app.worker.do_work&quot; , include : [ :arg1 , [ :arg2 , :count ] , :total , :result ] ) def do_work ( arg1 , arg2 ) do total = arg1 . count + arg2 . count { :ok , total } end end","ref":"OpenTelemetryDecorator.html#trace/4","title":"OpenTelemetryDecorator.trace/4","type":"function"}]